package com.sun.s1asdev.ejb.timer.timertests.client;

import java.io.Serializable;
import java.rmi.NoSuchObjectException;
import java.util.*;

import javax.ejb.*;
import javax.jms.*;
import javax.naming.*;
import javax.rmi.PortableRemoteObject;

import com.sun.s1asdev.ejb.timer.timertests.FooHome;
import com.sun.s1asdev.ejb.timer.timertests.Foo;

import com.sun.ejte.ccl.reporter.SimpleReporterAdapter;

public class Client {

    private InitialContext context;

    private static SimpleReporterAdapter stat = 
        new SimpleReporterAdapter("appserv-tests");

    public static void main(String args[]) { 
        stat.addDescription("ejb-timer-timertests");

        new Client().doFooTest("ejbs/Foo_CMT");

        stat.printSummary("ejb-timer-timertests");
    }

    // when running this class through the appclient infrastructure
    public Client() {
        try {
            context = new InitialContext();
        } catch(Exception e) {
            System.out.println("Client : new InitialContext() failed");
            e.printStackTrace();
            stat.addStatus("Client() ", stat.FAIL);
        }
    }

    public void doFooTest(String jndiName) {
        try {
            Context ic = new InitialContext();
            Object fooObjref = ic.lookup("java:comp/env/" + jndiName);

            System.out.println("Doing foo timer test for " + jndiName);
            FooHome  fooHome = (FooHome)PortableRemoteObject.narrow
                (fooObjref, FooHome.class);

            Foo foo = fooHome.create();
            System.out.println("doTest(): creating the the 1st timer");
            String SOME_XML = "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA";

            ArrayList info = new ArrayList();

            for (int i = 0; i < 250; i++) {
                info.add(SOME_XML);
            }

            foo.createTimer(1000, info);

            System.out.println("Foo : " + jndiName + " test passed!!");
            stat.addStatus("Foo: " + jndiName, stat.PASS);
        } catch(Exception e) {
            System.out.println("Foo : " + jndiName + " test failed");
            e.printStackTrace();
            stat.addStatus("Foo: " + jndiName, stat.FAIL);
        }
    }

}
